namespace TM.Bosman.Transforms {
    
    
    [Microsoft.XLANGs.BaseTypes.SchemaReference(@"TM.Shared.Schemas.Order", typeof(global::TM.Shared.Schemas.Order))]
    [Microsoft.XLANGs.BaseTypes.SchemaReference(@"TM.Shared.Schemas.Order", typeof(global::TM.Shared.Schemas.Order))]
    public sealed class TM_Bosman_Reference_Administration : global::Microsoft.XLANGs.BaseTypes.TransformBase {
        
        private const string _strMap = @"<xsl:stylesheet xmlns:xsl=""http://www.w3.org/1999/XSL/Transform"" version=""1.0""
                xmlns:ScriptNS0=""http://schemas.microsoft.com/BizTalk/2003/ScriptNS0""
                xmlns:ScriptNS1=""http://schemas.microsoft.com/BizTalk/2003/ScriptNS1""
                
                xmlns:DateTime=""TM.Shared.Components.DateTime""
                 xmlns:KeyList=""TM.Shared.Components.KeyList""
                     xmlns:SSO=""TM.Shared.Components.SSO""
                  xmlns:String=""TM.Shared.Components.String""
                
                xmlns:Bosman=""TM.Bosman.Components.MSsql""

                xmlns:s0=""http://TM.KLG.com/KLG/Order""
                xmlns:ns0=""http://TM.KLG.com/KLG/Order""
                
                exclude-result-prefixes=""s0 ns0 ScriptNS0 ScriptNS1 DateTime KeyList SSO String Bosman"">

  <xsl:output omit-xml-declaration=""yes"" method=""xml"" version=""1.0"" indent=""yes"" />

  <!-- Region global variable initialization -->

  <!-- end region -->

  <!-- region templates -->
  
  <xsl:template match=""/"">
    <xsl:apply-templates select=""/s0:Order"" />
  </xsl:template>

  <xsl:template match=""/s0:Order"">
    <ns0:Order>
      <Reference>
        <xsl:value-of select=""Reference""/>
      </Reference>
      <TimeStamp>
        <xsl:value-of select=""TimeStamp""/>
      </TimeStamp>
      <xsl:for-each select=""Shipment"">
        <ns0:Shipment>
          <ConsignorReference>
            <xsl:value-of select=""ConsignorReference""/>
          </ConsignorReference>
          <Update>
            <xsl:value-of select=""Bosman:AddReference(ConsignorReference)""/>
          </Update>
        </ns0:Shipment>
      </xsl:for-each>
    </ns0:Order>
  </xsl:template>

  <!-- end region -->

</xsl:stylesheet>";
        
        private const int _useXSLTransform = 0;
        
        private const string _strArgList = @"<ExtensionObjects>
  <ExtensionObject Namespace=""http://schemas.microsoft.com/BizTalk/2003/ScriptNS0"" 
                   AssemblyName=""Microsoft.BizTalk.BaseFunctoids, Version=3.0.1.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35"" 
                   ClassName=""Microsoft.BizTalk.BaseFunctoids.FunctoidScripts"" />
  <ExtensionObject Namespace=""http://schemas.microsoft.com/BizTalk/2003/ScriptNS1"" 
                   AssemblyName=""Microsoft.BizTalk.CrossReferencing, Version=3.0.1.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35"" 
                   ClassName=""Microsoft.BizTalk.CrossReferencing.CrossReferencing"" />

  <ExtensionObject Namespace=""TM.Shared.Components.Biztalk""
                   AssemblyName=""TM.Shared.Components, Version=3.0.37.0, Culture=neutral, PublicKeyToken=9cbf569b151cb1d4""
                   ClassName=""TM.Shared.Components.BiztalkFunctions"" />
  <ExtensionObject Namespace=""TM.Shared.Components.DateTime""
                   AssemblyName=""TM.Shared.Components, Version=3.0.37.0, Culture=neutral, PublicKeyToken=9cbf569b151cb1d4""
                   ClassName=""TM.Shared.Components.DateTimeFunctions"" />
  <ExtensionObject Namespace=""TM.Shared.Components.KeyList""
                   AssemblyName=""TM.Shared.Components, Version=3.0.37.0, Culture=neutral, PublicKeyToken=9cbf569b151cb1d4""
                   ClassName=""TM.Shared.Components.KeyListFunctions"" />
  <ExtensionObject Namespace=""TM.Shared.Components.SSO""
                   AssemblyName=""TM.Shared.Components, Version=3.0.37.0, Culture=neutral, PublicKeyToken=9cbf569b151cb1d4""
                   ClassName=""TM.Shared.Components.SSOFunctions"" />
  <ExtensionObject Namespace=""TM.Shared.Components.String""
                   AssemblyName=""TM.Shared.Components, Version=3.0.37.0, Culture=neutral, PublicKeyToken=9cbf569b151cb1d4""
                   ClassName=""TM.Shared.Components.StringFunctions"" />

  <ExtensionObject Namespace=""TM.Bosman.Components.MSsql""
                   AssemblyName=""TM.Bosman.Components, Version=3.0.0.0, Culture=neutral, PublicKeyToken=ef8f53020aeb0dca""
                   ClassName=""TM.Bosman.Components.MSsql"" />
  <ExtensionObject Namespace=""TM.Bosman.Components.Logging""
                   AssemblyName=""TM.Bosman.Components, Version=3.0.0.0, Culture=neutral, PublicKeyToken=ef8f53020aeb0dca""
                   ClassName=""TM.Bosman.Components.Logging"" />

</ExtensionObjects>";
        
        private const string _strSrcSchemasList0 = @"TM.Shared.Schemas.Order";
        
        private const global::TM.Shared.Schemas.Order _srcSchemaTypeReference0 = null;
        
        private const string _strTrgSchemasList0 = @"TM.Shared.Schemas.Order";
        
        private const global::TM.Shared.Schemas.Order _trgSchemaTypeReference0 = null;
        
        public override string XmlContent {
            get {
                return _strMap;
            }
        }
        
        public override int UseXSLTransform {
            get {
                return _useXSLTransform;
            }
        }
        
        public override string XsltArgumentListContent {
            get {
                return _strArgList;
            }
        }
        
        public override string[] SourceSchemas {
            get {
                string[] _SrcSchemas = new string [1];
                _SrcSchemas[0] = @"TM.Shared.Schemas.Order";
                return _SrcSchemas;
            }
        }
        
        public override string[] TargetSchemas {
            get {
                string[] _TrgSchemas = new string [1];
                _TrgSchemas[0] = @"TM.Shared.Schemas.Order";
                return _TrgSchemas;
            }
        }
    }
}
